﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
Sub Class_Globals
Type Point(x As Int, y As Int)
Dim GaugeType,x,y,w,h As Int
Dim BackCol As Int
Dim	Title,Display As String
Dim TextCol,GaugeCol,ColArr(4),TextSize As Int
Dim ptArray(50),gArray(50) As Point
Dim ID As Int
Dim GaugeColSolid As Boolean
Dim vMin,vMax As Int
Dim vType As String
Private BackPan As Panel
Dim Pnl As Panel
Dim cvs As Canvas
Type TouchValues(x As Float, y As Float)
Private TouchVal As TouchValues
Private EventString As String
Private CallBackModule As Object
Dim Tag As Int
Dim Moving As Boolean
Dim Sizing As Boolean
Dim Screen As Int ' screen number for storage only
Private r As Reflector
Private TempColor As Int
Private TempPanel As Panel
Private tr As Reflector
Private mx,my,tval As Int
Dim Command As String
End Sub

'Initializes the object.
Public Sub Initialize(vw As Panel,TypeOfGauge As Int,left As Int,top As Int,width As Int,height As Int, _
	EventModule As Object,CallBack As String)
BackPan = vw
EventString = CallBack
CallBackModule = EventModule
Moving = False
Sizing = False
x = left
y = top
w = width
h = height
GaugeType = TypeOfGauge
BackCol = Colors.DarkGray
TextCol = Colors.White
GaugeCol = Colors.Red
ColArr(0) = Colors.Green
ColArr(1) = Colors.Yellow
ColArr(2) = Colors.RGB(255,127,0)
ColArr(3) = Colors.Red
Pnl.Initialize("panel")
Pnl.Color = Colors.Transparent
vw.AddView(Pnl,x,y,w,h)
'cvs.Initialize(Pnl)
'"Simple","Arc","LED horizontal"
'Select GaugeType
'	Case 0 ' simple
'		InitSimple
'	Case 1 ' arc
'		InitArc
'	Case 2 ' led h
'		InitHLed
'End Select
InitGaugeType
r.Target = Pnl
r.SetOnTouchListener("View_Touch")
End Sub

Public Sub InitGaugeType
cvs.Initialize(Pnl)
'"Simple","Arc","LED horizontal"
Select GaugeType
	Case 0 ' simple
		InitSimple
	Case 1 ' arc
		InitArc
	Case 2 ' led h
		InitHLed
End Select
End Sub

Public Sub Draw(Value As String)
Select GaugeType
	Case 0 ' simple
		DrawSimple(Value)
	Case 1 ' arc
		DrawArc(Value)
	Case 2 ' led h
		DrawHLED(Value)
End Select
Pnl.Invalidate
End Sub

Private Sub InitSimple
TextSize = Utils.MaxTextSize("00000",cvs,w - 10, h - 60)
End Sub

Private Sub InitArc
Dim pA,pB,pC,pD As Point
Dim i,w1,h1 As Int
pA.x = 0
pA.y = h
pB.x = w/1.6 '200
pB.y = h/2 '70
pC.x = w/1.6 '200
pC.y = h/2 '70
pD.x = w
pD.y = h/2 '60
ptArray = GetBezierPoints(pA, pB, pC, pD,50) ' Calculate the curve points
pA.x = 0
pA.y = h - 10
pB.x = w/2 '200
pB.y = h/2.2 '70
pC.x = w/2 '200
pC.y = h/2.2 '70
pD.x = w
pD.y = 0
gArray = GetBezierPoints(pA, pB, pC, pD,50)
w1 = w - ptArray(25).x
h1 = h - ptArray(25).y
TextSize = Utils.MaxTextSize("00000",cvs,w1 - 5dip,h1 - 5dip)
End Sub

Private Sub GetBezierPoints(a1 As Point,b1 As Point,c1 As Point,d1 As Point,Steps As Int) As Point()
Dim Scale As Double
Dim S,Sn As Double
Dim i As Int
Dim x1,y1 As Double
Dim tArray(Steps + 1) As Point
Scale = 1 / Steps
S = 1
Sn = 0
For i = 0 To Steps
	x1 = (a1.x*S*S*S) + (b1.x*3*S*S*Sn) + (c1.x*3*S*Sn*Sn) + (d1.x*Sn*Sn*Sn)
  y1 = (a1.y*S*S*S) + (b1.y*3*S*S*Sn) + (c1.y*3*S*Sn*Sn) + (d1.y*Sn*Sn*Sn)
	tArray(i).x = Round2(x1,0)
	tArray(i).y = Round2(y1,0)
  S = S - Scale
  Sn = 1.0 - S
Next
Return tArray
End Sub

Private Sub InitHLed
Dim x1,y1,X2,Y2 As Int
Dim i As Int
Dim dW,dH,w1,h1 As Int
Dim ddW As Double
Dim aLedlt(50) As Point
Dim aLedrb(50) As Point
ddW = w
dW = Round((ddW - 4)/50)
dH = h/3
x1 = 2 'left
y1 = dH 'top
X2 = x1 + dW - 1 'right
Y2 = y1 + y1 'bottom
For i = 0 To 49
	aLedlt(i).x = x1 'left
	aLedlt(i).y = y1 'top
	aLedrb(i).x = X2 'right
	aLedrb(i).y = Y2 'bottom
	'Shift X and X2 by dW
	x1 = x1 + dW
	X2 = X2 + dW
Next
w1 = w - 10dip ' textsize
h1 = (h - Y2) - 10dip
TextSize = Utils.MaxTextSize("00000",cvs,w1,h1)
ptArray = aLedlt
gArray = aLedrb
End Sub

Private Sub DrawSimple(V As String)
Dim rect1 As Rect
rect1.Initialize(0,0,w,h)
cvs.DrawRect(rect1,BackCol,True,1)
cvs.DrawText(Title,w/2,20,Typeface.DEFAULT,14,TextCol,"CENTER")
cvs.DrawText(V,w/2,h - 25dip,Typeface.DEFAULT,TextSize,GaugeCol,"CENTER")
'aGaugeBase.cBase.DrawText(val,w/2,h - (h/2.5),Typeface.DEFAULT,w/3,aGauge.GaugeCol,"CENTER")
cvs.DrawText(Display,w/2,h - 5dip,Typeface.DEFAULT,14,TextCol,"CENTER")
'aGaugeBase.cBase.DrawBitmap(aGauge.bmp,rect1,rect1)
Pnl.Invalidate
End Sub

Private Sub DrawArc(V As String)

End Sub

Private Sub DrawHLED(V As String)

End Sub

Public Sub SetSize(width As Int,height As Int)

End Sub

Public Sub SetType(NewType As Int)

End Sub

Public Sub GetRect As Rect
Dim rect1 As Rect
rect1.Initialize(x,y,w,h)
Return rect1
End Sub

Public Sub Delete
Pnl.RemoveView
End Sub

Private Sub panel_LongClick
If SubExists(CallBackModule,EventString & "_LongClick") = True Then
	CallSub2(CallBackModule,EventString & "_LongClick",Tag) 'call click event
End If
End Sub

Public Sub TouchMove
Moving = True
End Sub

Private Sub View_Touch(ViewTag As Object,Action As Int,ax As Float,ay As Float,MotionEvent As Object) As Boolean
Dim Now As Long
Dim tt As TouchType
If Moving = False AND Sizing = False Then
	tt.Initialize
	tt.Action = Action
	tt.x = ax
	tt.y = ay
	If SubExists(CallBackModule,EventString & "_BackTouch") = True Then
		CallSub2(CallBackModule,EventString & "_BackTouch",tt) 'call click event
	End If
	Return False
End If ' If Moving = True
Select Action
	Case 0 ' DOWN
		TouchVal.x = ax
		TouchVal.y = ay
		tval = GetTouchCell(TouchVal,w,h) ' get the section that was touched
		Return True
	Case 1 ' UP
		x = TempPanel.Left
		y = TempPanel.Top
		w = TempPanel.Width
		h = TempPanel.Height
		Pnl.Left = x
		Pnl.Top =y
		If Sizing = True Then
			Pnl.Width = w
			Pnl.Height = h
			InitGaugeType
		End If
		Moving = False
		Sizing = False
		DeSelectGauge
		Return True
	Case 2 ' MOVE/SIZE
		If Moving = True Then
  		TempPanel.Left = TempPanel.Left + Round(ax) - Round(TouchVal.x)
			TempPanel.Top = TempPanel.Top + Round(ay) - Round(TouchVal.y)
			Moving = True
		End If
		If Sizing = True Then
			'1	2	3
			'4	5	6
			'7	8	9
			mx = Round(ax) - Round(TouchVal.x)
			my = Round(ay) - Round(TouchVal.y)
			Select tval
				Case 1
					TempPanel.Top = TempPanel.Top + Round(ay) - Round(TouchVal.y) ' y axis
					TempPanel.Height = TempPanel.Height - my
					TempPanel.Left = TempPanel.Left + Round(ax) - Round(TouchVal.x) ' x axis
					TempPanel.Width = TempPanel.Width - mx
				Case 2
					TempPanel.Top = TempPanel.Top + Round(ay) - Round(TouchVal.y) ' y axis
					TempPanel.Height = TempPanel.Height - my
				Case 3
					TempPanel.Top = TempPanel.Top + Round(ay) - Round(TouchVal.y) ' y axis
					TempPanel.Height = TempPanel.Height - my
					TempPanel.Width = TempPanel.Width + Round(ax) - TempPanel.Width ' x axis
				Case 4
					TempPanel.Left = TempPanel.Left + Round(ax) - Round(TouchVal.x)
					TempPanel.Width = TempPanel.Width - mx
				Case 6 ' x axis
					TempPanel.Width = TempPanel.Width + Round(ax) - TempPanel.Width
				Case 7
					TempPanel.Left = TempPanel.Left + Round(ax) - Round(TouchVal.x) ' x axis
					TempPanel.Width = TempPanel.Width - mx
					TempPanel.Height = TempPanel.Height + Round(ay) - TempPanel.Height ' y axis
				Case 8 ' y axis
					TempPanel.Height = TempPanel.Height + Round(ay) - TempPanel.Height ' y axis
				Case 9
					TempPanel.Width = TempPanel.Width + Round(ax) - TempPanel.Width
					TempPanel.Height = TempPanel.Height + Round(ay) - TempPanel.Height ' y axis
			End Select
			If TempPanel.Width > 100%x Then TempPanel.Width = 100%x ' limit the size
			If TempPanel.Height > 100%y Then TempPanel.Height = 100%y
			Sizing = True
		End If	
		TempPanel.Invalidate
		Return True ' We trap the Touch event
End Select
Return True 'Default return
End Sub

'1	2	3
'4	5	6
'7	8	9
'Gets cell value of touch as above
Private Sub GetTouchCell(tv As TouchValues,wth As Int,hgt As Int) As Int
Dim resarray(3,3,3) As Int
Dim vx,vy,cx,cy As Int
' Convert Val to percent
vx = (tv.x/wth) * 100
vy = (tv.y/hgt) * 100
If vx < 30 Then
	cx = 0 ' 1,4 or 7 cx=0
Else
	If vx < 60 Then
		cx = 1 ' 2,5 or 8 cx=1
	Else
		cx = 2 ' 3,6 or 9 cx=2
	End If
End If
If vy < 30 Then
	cy = 0 ' 1,2 or 3 cy=0
Else
	If vy < 60 Then
		cy = 1 ' 4,5 or 6 cy=1
	Else
		cy = 2 ' 7,8 or 9 cx=2
	End If
End If
Select cy
	Case 0
		If cx = 0 Then Return 1
		If cx = 1 Then Return 2
		If cx = 2 Then Return 3
	Case 1
		If cx = 0 Then Return 4
		If cx = 1 Then Return 5
		If cx = 2 Then Return 6
	Case 2
		If cx = 0 Then Return 7
		If cx = 1 Then Return 8
		If cx = 2 Then Return 9
End Select
End Sub

'Removes the gauge from the list
Public Sub Remove
r.Target = Null
Pnl.RemoveView
End Sub

'Hides original panel and adds transparent panel
' for sizing or moving
Public Sub SelectGauge(Colour As Int)
TempPanel.Initialize("")
TempPanel.Color = Colour
Pnl.Visible = False
BackPan.AddView(TempPanel,x,y,w,h)
tr.Target = TempPanel
tr.SetOnTouchListener("View_Touch")
End Sub

'Removes transparent panel and restores original
Public Sub DeSelectGauge
tr.Target = Null
Pnl.Left = x
Pnl.Top = y
Pnl.Width = w
Pnl.Height = h
TempPanel.RemoveView
Pnl.Visible = True
Draw("0")
End Sub

