﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
Sub Class_Globals
'Dim gList As List
Dim gArray() As Gauge
Dim Count As Int
Private dummyView As View
Private SensorList As Sensors
Private NumGauges As Int
Private CallBackModule As Object ' e.g. Me
Private CallBack As String ' for all gauges
Private eval As Evaluator
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(ArraySize As Int,ListOfSensors As Sensors,Module As Object,EventString As String)
eval.Initialize
CallBackModule = Module
CallBack = EventString
NumGauges = ArraySize
Dim gArray(NumGauges) As Gauge
Count = 0
SensorList = ListOfSensors
End Sub

Public Sub Add(Pan As Panel,GaugeType As Int,left As Int,top As Int,width As Int,height As Int,aPID As Int,ScnNum As Int) As Int
Dim g As Gauge
If Count > NumGauges - 1 Then Return
g.Initialize(Pan,GaugeType,left,top,width,height,CallBackModule,CallBack)
g.ID = aPID
g.Title = SensorList.pArray(aPID).ShortDesc
g.Display = SensorList.pArray(aPID).Display
g.vMax = SensorList.pArray(aPID).Maximum
g.vMin = SensorList.pArray(aPID).Minimum
g.vType = SensorList.pArray(aPID).Display
g.Tag = Count 'identity for the gauge
g.Screen = ScnNum
g.Command = SensorList.pArray(aPID).HexPID
gArray(Count) = g
Count = Count + 1
Return Count - 1
End Sub

'Draw the gauge with this index
Public Sub DrawIndex(Index As Int,v As String,ScnNum As Int)
If Count < Index Then Return
If gArray(Index).Screen = ScnNum Then
	gArray(Index).Draw(v)
End If
End Sub

Public Sub PIDOnScreen(HexPID As String,ScnNum As Int) As Boolean
For i = 0 To Count - 1
	If gArray(i).Screen = ScnNum Then
		If gArray(i).Command = HexPID Then
			Return True
		End If
	End If
Next
Return False
End Sub

'Draws all gauges with this PID
Public Sub DrawAllPID(aPID As Int,v As String,ScnNum As Int)
For i = 0 To Count - 1
	If gArray(i).Screen = ScnNum Then
		If gArray(i).ID = aPID Then
			gArray(i).Draw(v)
		End If
	End If
Next
End Sub

'calculate values and display in gauge
Public Sub CalcAndDisplay(aPID As Int,bytes() As Int,ScnNum As Int)
Dim aA,aB,aC,aD As Double
Dim res As Double
Dim err,val As String
aA = 0
aB = 0
aC = 0
aD = 0
aA = bytes(0) ' convert 1st byte to double
If bytes.Length > 1 Then aB = bytes(1) ' and second etc
If bytes.Length > 2 Then aC = bytes(2)
If bytes.Length > 3 Then aD = bytes(3)
eval.SetGlobal("A",aA)
eval.SetGlobal("B",aB)
eval.SetGlobal("C",aC)
eval.SetGlobal("D",aD)
res = eval.Evaluate(SensorList.pArray(aPID).Formula)
err = eval.Error
If SensorList.pArray(aPID).Unit = "Int" Then
	val = Round(res)
Else
	val = NumberFormat(res,1,2)
End If
DrawAllPID(aPID,val,ScnNum)
If err <> "" Then Log("Error:" & err)
End Sub

'Returns the number of aPIDs in use
Public Sub FindPID(aPID As Int)
Dim res As Int
res = 0
For i = 0 To Count - 1
	If gArray(i).ID = aPID Then
		res = res + 1
	End If
Next
Return res
End Sub

'Draws all gauges containing ScnNum with value v
Public Sub DrawScreen(ScnNum As Int,v As String)
For i = 0 To Count - 1
	If gArray(i).Screen = ScnNum Then
		gArray(i).Draw(v)
	End If
Next
End Sub

Public Sub Delete(Index As Int)
Dim lst As List
lst.Initialize
For i = 0 To Count - 1
	lst.Add(gArray(i))
Next
lst.RemoveAt(Index)
gArray(Index).Remove
Count = lst.Size
Dim gArray(NumGauges) As Gauge
For i = 0 To Count - 1
	gArray(i) = lst.Get(i)
	gArray(i).Tag = i
Next
lst.Clear
End Sub

Public Sub DeleteAll
For i = 0 To Count - 1
	gArray(i).Remove
Next
Dim gArray(NumGauges) As Gauge
Count = 0
End Sub

Public Sub TouchMove(id As Int)
gArray(id).TouchMove
End Sub

