﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
Sub Class_Globals
Dim SlidingDuration As Int : SlidingDuration = 200
'**** SlidingData ****
Dim FirstTime As Boolean
Dim CurrentPanel As Int
Dim Panels() As Panel
Dim LeftAnimations() As Animation
Dim RightAnimations() As Animation
Dim TargetPanel As Int
'***********************	
Private TmrAnimation As Timer
Private Act As Activity
Private startX, startY As Float
Dim Indicator As Panel
Dim ActiveBitmap As Bitmap
Dim InactiveBitmap As Bitmap
Private EventString As String
Private CallBackModule As Object
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Actvty As Activity,NumPanels As Int,EventModule As Object,CallBack As String)
Dim Panels(NumPanels) As Panel
Act = Actvty
EventString = CallBack
CallBackModule = EventModule
For i = 0 To Panels.Length - 1
	Panels(i).Initialize("panels")
	Panels(i).Color = Colors.Transparent
	Act.AddView(Panels(i), 100%x, 0, 100%x, 100%y - 40dip) 'add the panel to the layout
Next
TmrAnimation.Initialize("tmrAnimation", 2)
Dim a(2) As Animation
LeftAnimations = a
Dim a(2) As Animation
RightAnimations = a
'Initialize the animation objects. We need two objects for each direction as both the current panel and the new panel are animated.
For i = 0 To 1
	LeftAnimations(i).InitializeTranslate("animation" & i, 0, 0, -100%x, 0)
	LeftAnimations(i).Duration = SlidingDuration
	RightAnimations(i).InitializeTranslate("animation" & i, 0, 0, 100%x, 0)
	RightAnimations(i).Duration = SlidingDuration
Next
For i = 0 To Panels.Length - 1
	Panels(i).Left = 100%x 'Move the panels right of the screen
Next
	'Load Bitmaps for indicator
ActiveBitmap.Initialize(File.DirAssets, "indicator_active.png")
InactiveBitmap.Initialize(File.DirAssets, "indicator_inactive.png")
Indicator = CreatePageIndicator(Panels.Length, InactiveBitmap, 100dip, 16dip)
Act.AddView(Indicator,(100%x - 100dip) / 2,100%y - 32dip, 100dip, 16dip)
Indicator.BringToFront
FirstTime = True
TargetPanel = -1
CurrentPanel = -1
End Sub

Sub Animation1_AnimationEnd
Panels(CurrentPanel).Left = 0 'Set the position of the new panel
For i = 0 To Panels.Length - 1
	If i <> CurrentPanel Then Panels(i).Left = 100%x 'Move all other panels right of the screen.
Next
If TargetPanel >= 0 Then 
	TmrAnimation.Enabled = True
	Return 'we are still animating...
End If
	'set the indicator to the correct page.
SetPageIndicator(Indicator,CurrentPanel, ActiveBitmap, InactiveBitmap)
End Sub

Public Sub ChangePanel(left As Boolean)
If left Then			
	If FirstTime = False Then 'remove current panel if such exists (it will not be the case on the first call).
		LeftAnimations(0).Start(Panels(CurrentPanel)) 'Animate current panel and move it out
	Else
		FirstTime = False
	End If
	LeftAnimations(1).Start(Panels((CurrentPanel + 1) Mod Panels.Length)) 'Animate new panel
	CurrentPanel = (CurrentPanel + 1) Mod Panels.Length
Else
	Dim leftPanel As Int
	leftPanel = (CurrentPanel + Panels.Length - 1) Mod Panels.Length
	Panels(leftPanel).left = -100%x
	RightAnimations(0).Start(Panels(CurrentPanel))
	RightAnimations(1).Start(Panels(leftPanel))
	CurrentPanel = leftPanel
End If
If SubExists(CallBackModule,EventString & "_PanelChanged") = True Then
	CallSub2(CallBackModule,EventString & "_PanelChanged",CurrentPanel) 'call click event
End If
End Sub

Private Sub tmrAnimation_Tick
	TmrAnimation.Enabled = False
	ContinueJumping
End Sub

'JumpToPanel can be used to navigate to a different panel which is not adjacent to the current one.
Public Sub JumpToPanel (Target As Int)
TargetPanel = Target
For i = 0 To 1
	LeftAnimations(i).Duration = SlidingDuration / 2
	RightAnimations(i).Duration = SlidingDuration / 2
Next
ContinueJumping
End Sub

Private Sub ContinueJumping
If TargetPanel < 0 OR TargetPanel = CurrentPanel Then 
	TargetPanel = -1
	Animation1_AnimationEnd
	For i = 0 To 1
		LeftAnimations(i).Duration = SlidingDuration
		RightAnimations(i).Duration = SlidingDuration
	Next
	Return
End If
ChangePanel(TargetPanel > CurrentPanel)
End Sub

Public Sub Panels_Touch(Action As Int, X As Float, Y As Float)
Select Action
	Case Act.ACTION_DOWN
		startX = X
		startY = Y
	Case Act.ACTION_UP
		If Abs(Y - startY) > 20%y Then Return
		If X - startX > 30%x Then 'AND btnRight.Enabled = True Then 
			ChangePanel(False)
		Else If startX - X > 30%x Then 'AND btnLeft.Enabled = True Then
			ChangePanel(True)
		End If
	End Select
End Sub

Private Sub CreatePageIndicator(numberOfPages As Int, InactBitmap As Bitmap, Width As Int, Height As Int) As Panel
Dim imageSize, maxWidth, Gap, Top As Int
maxWidth = Width / numberOfPages
If maxWidth < Height Then
	imageSize = maxWidth
	Top = (Height - maxWidth) / 2
	Gap = 0
Else
	imageSize = Height
	Top = 0
	Gap = (Width - numberOfPages * imageSize) / (numberOfPages - 1)
End If
Dim basePanel As Panel
basePanel.Initialize("")
For i = 0 To numberOfPages - 1
	Dim iv As ImageView
	iv.Initialize("")
	iv.Gravity=Gravity.FILL
	iv.Bitmap = InactBitmap
	basePanel.AddView(iv, i * (imageSize + Gap), Top, imageSize, imageSize)
Next
Return basePanel
End Sub

Private Sub SetPageIndicator(pagePanel As Panel, page As Int, ActBitmap As Bitmap, InactBitmap As Bitmap)
Dim v As View
Dim iv As ImageView
For i = 0 To pagePanel.NumberOfViews - 1
	v = pagePanel.GetView(i)
	If v Is ImageView Then
		iv = v
		If i = page Then
			iv.Bitmap = ActBitmap
		Else
			iv.Bitmap = InactBitmap
		End If
	End If
Next
End Sub

